# -*- coding: utf-8 -*-

"""
cuadraai

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from cuadraai.api_helper import APIHelper
from cuadraai.exceptions.api_exception import ApiException


class ErrorResponseException(ApiException):
    def __init__(self, reason, response):
        """Constructor for the ErrorResponseException class

        Args:
            reason (string): The reason (or error message) for the Exception
                to be raised.
            response (HttpResponse): The HttpResponse of the API call.

        """
        super(ErrorResponseException, self).__init__(reason, response)
        dictionary = APIHelper.json_deserialize(self.response.text)
        if isinstance(dictionary, dict):
            self.unbox(dictionary)

    def unbox(self, dictionary):
        """Populates the properties of this object by extracting them from a dictionary.

        Args:
            dictionary (dictionary): A dictionary representation of the object as
            obtained from the deserialization of the server's response. The keys
            MUST match property names in the API description.

        """
        self.message = dictionary.get("message") if dictionary.get("message") else None
        self.status = dictionary.get("status") if dictionary.get("status") else None
        self.field_errors = dictionary.get("field_errors") if "field_errors" in dictionary.keys() else None

    def __str__(self):
        base_str = super().__str__()
        return (f'{self.__class__.__name__}('
                f'{base_str[base_str.find("(") + 1:-1]}, '
                f'message={(self.message if hasattr(self, "message") else None)!s}, '
                f'status={(self.status if hasattr(self, "status") else None)!s}, '
                f'field_errors={(self.field_errors if hasattr(self, "field_errors") else None)!s})')
