# -*- coding: utf-8 -*-

"""
cuadraai

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from cuadraai.api_helper import APIHelper
from cuadraai.models.content_ex import ContentEx


class Embed(object):

    """Implementation of the 'Embed' model.

    Attributes:
        model (str): Model name
        content (List[ContentEx]): Request content
        purpose (str): The purpose of the embed, it could be
            'search_document', 'search_query', 'classification', o
            'clustering'.
        additional_properties (Dict[str, Any]): The additional properties for
            the model.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "model": 'model',
        "content": 'content',
        "purpose": 'purpose'
    }

    def __init__(self,
                 model=None,
                 content=None,
                 purpose=None,
                 additional_properties=None):
        """Constructor for the Embed class"""

        # Initialize members of the class
        self.model = model 
        self.content = content 
        self.purpose = purpose 

        # Add additional model properties to the instance
        if additional_properties is None:
            additional_properties = {}
        self.additional_properties = additional_properties

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        model = dictionary.get("model") if dictionary.get("model") else None
        content = None
        if dictionary.get('content') is not None:
            content = [ContentEx.from_dictionary(x) for x in dictionary.get('content')]
        purpose = dictionary.get("purpose") if dictionary.get("purpose") else None
        additional_properties = APIHelper.get_additional_properties(
            dictionary={k: v for k, v in dictionary.items() if k not in cls._names.values()},
            unboxing_function=lambda value: value)
        # Return an object of this model
        return cls(model,
                   content,
                   purpose,
                   additional_properties)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'model={self.model!r}, '
                f'content={self.content!r}, '
                f'purpose={self.purpose!r}, '
                f'additional_properties={self.additional_properties!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'model={self.model!s}, '
                f'content={self.content!s}, '
                f'purpose={self.purpose!s}, '
                f'additional_properties={self.additional_properties!s})')
