# -*- coding: utf-8 -*-

"""
cuadraai

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from cuadraai.api_helper import APIHelper
from cuadraai.models.model_ex import ModelEx


class PaginatedResponseExListModelEx(object):

    """Implementation of the 'PaginatedResponseExListModelEx' model.

    Attributes:
        page (int): The model property of type int.
        size (int): The model property of type int.
        data (List[ModelEx]): The model property of type List[ModelEx].
        additional_properties (Dict[str, Any]): The additional properties for
            the model.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "page": 'page',
        "size": 'size',
        "data": 'data'
    }

    _optionals = [
        'page',
        'size',
        'data',
    ]

    def __init__(self,
                 page=APIHelper.SKIP,
                 size=APIHelper.SKIP,
                 data=APIHelper.SKIP,
                 additional_properties=None):
        """Constructor for the PaginatedResponseExListModelEx class"""

        # Initialize members of the class
        if page is not APIHelper.SKIP:
            self.page = page 
        if size is not APIHelper.SKIP:
            self.size = size 
        if data is not APIHelper.SKIP:
            self.data = data 

        # Add additional model properties to the instance
        if additional_properties is None:
            additional_properties = {}
        self.additional_properties = additional_properties

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        page = dictionary.get("page") if dictionary.get("page") else APIHelper.SKIP
        size = dictionary.get("size") if dictionary.get("size") else APIHelper.SKIP
        data = None
        if dictionary.get('data') is not None:
            data = [ModelEx.from_dictionary(x) for x in dictionary.get('data')]
        else:
            data = APIHelper.SKIP
        additional_properties = APIHelper.get_additional_properties(
            dictionary={k: v for k, v in dictionary.items() if k not in cls._names.values()},
            unboxing_function=lambda value: value)
        # Return an object of this model
        return cls(page,
                   size,
                   data,
                   additional_properties)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'page={(self.page if hasattr(self, "page") else None)!r}, '
                f'size={(self.size if hasattr(self, "size") else None)!r}, '
                f'data={(self.data if hasattr(self, "data") else None)!r}, '
                f'additional_properties={self.additional_properties!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'page={(self.page if hasattr(self, "page") else None)!s}, '
                f'size={(self.size if hasattr(self, "size") else None)!s}, '
                f'data={(self.data if hasattr(self, "data") else None)!s}, '
                f'additional_properties={self.additional_properties!s})')
