# -*- coding: utf-8 -*-

"""
cuadraai

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from cuadraai.api_helper import APIHelper
from cuadraai.models.tokens_ex import TokensEx


class UsageEx(object):

    """Implementation of the 'UsageEx' model.

    This is the token usage result of your request

    Attributes:
        billed_tokens (TokensEx): Tokens used
        used_tokens (TokensEx): Tokens used
        additional_properties (Dict[str, Any]): The additional properties for
            the model.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "billed_tokens": 'billedTokens',
        "used_tokens": 'usedTokens'
    }

    _optionals = [
        'billed_tokens',
        'used_tokens',
    ]

    def __init__(self,
                 billed_tokens=APIHelper.SKIP,
                 used_tokens=APIHelper.SKIP,
                 additional_properties=None):
        """Constructor for the UsageEx class"""

        # Initialize members of the class
        if billed_tokens is not APIHelper.SKIP:
            self.billed_tokens = billed_tokens 
        if used_tokens is not APIHelper.SKIP:
            self.used_tokens = used_tokens 

        # Add additional model properties to the instance
        if additional_properties is None:
            additional_properties = {}
        self.additional_properties = additional_properties

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        billed_tokens = TokensEx.from_dictionary(dictionary.get('billedTokens')) if 'billedTokens' in dictionary.keys() else APIHelper.SKIP
        used_tokens = TokensEx.from_dictionary(dictionary.get('usedTokens')) if 'usedTokens' in dictionary.keys() else APIHelper.SKIP
        additional_properties = APIHelper.get_additional_properties(
            dictionary={k: v for k, v in dictionary.items() if k not in cls._names.values()},
            unboxing_function=lambda value: value)
        # Return an object of this model
        return cls(billed_tokens,
                   used_tokens,
                   additional_properties)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'billed_tokens={(self.billed_tokens if hasattr(self, "billed_tokens") else None)!r}, '
                f'used_tokens={(self.used_tokens if hasattr(self, "used_tokens") else None)!r}, '
                f'additional_properties={self.additional_properties!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'billed_tokens={(self.billed_tokens if hasattr(self, "billed_tokens") else None)!s}, '
                f'used_tokens={(self.used_tokens if hasattr(self, "used_tokens") else None)!s}, '
                f'additional_properties={self.additional_properties!s})')
